'Calculates a freerunning timer0 refresh clock

xtal = 3686400 'the PICs main crystal in Hz
digits = 4 'the number of digits you want to refresh
minrate = 40 'minimum refresh rate per digit
baud = 9600 'desired baud rate for USART

print "  PIC clock calculator"
clock = xtal /4 /256 'max freerunning speed of timer0

for i=8 to 0 step -1
  if (clock/2^i+1)/digits >= minrate then exit
next i
 
if i=-1 then print "Oscilator too slow for refresh" :end

print "With the TIMER0 prescaler set for 1/";2^i
print "TIMER0 will overflow ";clock /2^i+1;" times per second"
print "A ";digits;" digit display will refresh at ";(clock/2^i+1)/digits;" hz per digit."
print 
print "Hardware UART setting for ";baud;" BAUD"

'Baud clock
SSPLo = round(xtal / baud / 64) -1

Print "SSP Lo ";SSPLo, "Actual "; round(Xtal / 64 /(SSPLo+1))
SSPHi = round(xtal / Baud / 16) -1

Print "SSP Hi ";SSPHi, "Actual "; round(Xtal / 16 /(SSPHi+1))